package test.data;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import test.bean.Book;

public class BooksDataAccess {
	//フィールド
	private static final String DRIVER = "com.mysql.jdbc.Driver";
	private static final String URL = "jdbc:mysql://localhost:3306/books?characterEncoding=utf8";
	private static final String USER = "root";
	private static final String PASSWORD = "";
	
	private Connection con;
	
	//コンストラクター
	public BooksDataAccess() throws SQLException, ClassNotFoundException {
		//データベースに接続する
		Class.forName(DRIVER);
		con = DriverManager.getConnection(URL, USER, PASSWORD);
	}
	
	//メソッド
	public Book getBook(int id) throws SQLException {
		//SQL文を生成
		String sql = "SELECT * FROM books WHERE id=?";
		
		//PreparedStatementオブジェクトを生成
		PreparedStatement pst = con.prepareStatement(sql);
		
		//パラメーターをセットする
		pst.setInt(1, id);
		
		//SQL文を実行
		ResultSet rs = pst.executeQuery();
		
		//結果を格納するBookオブジェクトを用意
		Book book = null;
		
		//結果を取得する
		if(rs.next()){
			book = new Book(
					rs.getInt("id"), 
					rs.getInt("category_id"), 
					rs.getString("book_name"), 
					rs.getString("author"), 
					rs.getString("publish"), 
					rs.getString("isbn"), 
					rs.getInt("price"), 
					rs.getInt("rental_state") == 1 ? true : false);
		}
		
		//データベースを切断する
		rs.close();
		this.close();
		
		//Bookオブジェクトを返す
		return book;
	}
	
	public void close() throws SQLException {
		this.con.close();
	}
}
